Hi!
I'm back with a new contest, a new color, and a new batch of xor problems.
Codeforces round #525, rated for the second division, is taking place on 04.12.2018 17:35 (Московское время). As usual, first division participants can take part out of competition.
I'm the problemsetter of the round. I'd like to thank 300iq for the great effort coordinating the round, isaf27, cdkrot, budalnik, and vintage_Vlad_Makeev for testing the round, scanhex for translating the statements to Russian, mahmoudbadawy for giving his opinions about the problems, and MikeMirzayanov for the great codeforces and polygon platforms.
Like my previous round, you'll be given 6 problems and 2 hours to solve them.
After the contest, I'll be on the community Discord server to discuss the problems.
UPD: the scoring distribution will be 500-1000-1500-2000-2500-3000.
UPD: something wrong happened and the editorial was deleted. I'll post it as soon as possible :(
UPD: the editorial has been re-written.
Good luck & Have fun!
UPD: congratulations to the winners!
Div.1+Div.2:-
Div.2:-
xor problems
will fuck these problems..... XD.
Egyptian problem setters , great ^^
Generally xor problems are really nice problems, hope this contest will be nice too.
Really? This might be an unpopular opinion, but I feel like xor problems often involve the same few tricks (trie, solving the problem for each bit independently, making use of the involution property, segment tree of xor's, etc.).
What is the involution property?
An involution is a function f: x -> x that, when applied twice, brings one back to the starting point. -Wikipedia
Good!
Thanks :)
your previous round was one of the best rounds i've seen since i join codeforces
hope to see such a great contest again
my favourite colour is green
And my favorite color is red with a little black; so what? :)
i will try my best to solve some problem , and get higher rating :')
Mahmoud and Ehab and the Xor, Mahmoud and Ehab and Xor-MST. These problems are freaking difficult and awesome. Expecting more difficult and great problems ;)
good
wow , my friend :D , hope you'll become green after this contest :D
i will become black after this contest, this contest is difficult
Let the strongest be lucky at the contest. All the will of Allah. You can't keep an eagle in a cage.Inshallah!
Whats up with long submission queues!
It disappeared.
I can't help, but remember:
https://www.youtube.com/watch?v=gOIscbt41KA
Good Luck for us all
GO vintage_Vlad_Makeev GO for newbie this time :P.
He is the tester of this round.
With the kind of determination vintage_Vlad_Makeev is showing in making his rating fall, he'll definitely beat the lowest rating of worse one day.
nobody can beat worse,even tourist
Maybe that's why he wants to achieve this feat. :)
Is it rated?
rated for the second division
you did not need to use bold letters.
ok.
sorry i cant read
it says it is rated
?
im not understend!!!!
I can't submit my code. Please help me.
I tried to send some codes with several languages, but the system always says "You have submitted exactly the same code before", even though "My submission" is still empty.
The scoring distribution provided here seems not matching the ones in standings page.
Please have a look.
Problem C seems buggy
Your code.
input:
3
x x x
output:
4
2 3 1
1 1 1
1 2 1
1 3 1
what's wrong here?
You received this array:
3 2 1
In short, you got things wrong quite a bit.
I have a dream...
that one day...
problems will go from easy to hard GRADUALLY and not like this
Someone else having problems with the interactor of problem D???
yesssss
It's printing things I am not asking it to print !!! This is crazy, I wrote a solution in the 34 minute and it still didn't pass the first test !!! I don't know what is it printing :(
for me it says my answer is "60" , it's not even possible to mycode print it ;
Same here, printing 30 -_-
I think 60 is the number of questions you made not the real output of your program
after any print i have endl .
Guys, interactive tasks are technically different in preparation :/ The output shown to you is the number of questions. Sorry if it made an inconvenience but some people asked in the clarifications and we cleared it.
It is possible to write an interactor in a different way — printing the participant's answer, not a number of questions. Interactor should exit with WA if query limit is exceeded. And checker should check the answer if the interactor finishes successfully. For me, it is the most convenient way.
And yes, I consider MikeMirzayanov's approach with printing number of queries as a bad practice :)
what's wrong with problem D ??? i test it in my system and in custom test and i get correct answer in test 1 and when i submit that i gave wrong :///////
same here
I think it's wrong.
You might print more than 62 questions
my code print at most 61 question , it's not possible ;
Can you show your code please?
hear ??
man, i just want to see how you implemented D
It's open to see other peaples' code now.
Is the idea for F that output tree must be a strict min heap. And now first value is hoax. For second value we need what is min value in 2^i distance tree from every vertex? How to do find min value in 2^i distance tree for all vertices ??
F is only about extracting information from the statement. Let's interpret w as sum of cost of edges. Now, what we need is to find the minimum spanning tree. In the first tree, root at minimum value vertex. For each vertex, we only concern about edges connect it with 2i-th ancestor or root.
me.
Oh God I forgot question marks in D
In any universe will this code print 30 for problem D???
link
Because you wrote "for(int i=0;i<30;i++)" instead of "for(int i=29;i>=0;i--)", thus your algorithm is wrong?! x)
i wrote for(int i=29;i>=0;i--) :P
My upvote is for the rick in the profile pic and multiverse reference in the comment.
i'm so stupid today. I don't think that a and b in problem A can be equal :(
i think one of the pretest needed a and b to be equal the first one i sent(thinking they couldn't be equal) got WA on test 10 i changed the one line and got accepted
-
Solution for E: Observation: the biggest fraction is always equal to the answer for k = 1 : the subtree with maximum sum. How to choose more components now? They all must have sum equal to maximum sum in a subtree, otherwise the fraction won't be the biggest
So first we find answer for k = 1 dp on trees. dp[x] = the best subtree rooted at x
dp[x] = val[x] + sum(max(0, dp[y]) | y is son of x); We calculate this dp using dfs.
Let us denote maximum sum of a subtree with M.
Now we can do a greedy to find maximum number of subtrees. We reapply the first dp algorithm again, but now when we obtain that dp[x] = M, we pick this subtree in answer, and disregard node x so it won't influence answer for father of x.
How to solve D?
XOR with powers of 2
Could you elaborate more? What do we achieve by this?
first you ask it ? 0 0 and know which one is bigger ( name it first comp ) , then you ask all power of 2 between 0 to 29 , if the comparison was the same with first comp then both have it or both don't have it so you ask c = 2^i and d = 0 and know they both have it or not , and if it wasn't same with first comp then the biggest one has it .
Just find non-equal bits, then you can easily restore equal bits. To find first one if answer for (a, b) differs from answer for (a+1^i, b+1^i) change a and b.
I got stuck restoring equal bits, how do you achieve that?
ask (a+2^i, b) if it's -1 then both are 1, else both are 0
How do you restore the equal bits?
Let a = a1a2... a30 and similarly define b. We will find bits from MSB to LSB. Initially find the result with c = 0, d = 0. This will give you a comparison between a and b. Let us call this r.
Now suppose we are discovering (i)th bit. We will always keep c = a1a2... ai - 1 and similarly d. Now query for c + 2i, d + 2i. If the result is opposite of r then you know the values of ai, bi and ai ≠ bi. Here you will need to update r once again for unknown bits.
Else we have ai = bi. Here you do not need to update r :). So, to find the value of ai, bi just query c, d + 2i.
interesting problems, thank you
xor + interactive
Can anyone explain the second sample of problem F? I can't get 44 from the optimal tree.
I felt like tourist when I solved A in 1 min xD
I feel like tourist when I travel around the world.
i do not care
Yet you still made a comment.
Say goodnight.
you have brain damage
Thanks for pointing out. Not many people knows about my poor brain health, yet you do precisely.
We can make good friends actually.
make this platform hacker free..... my solution just got hacked.. use good antivirus
Pakistan, apni akal kabar me khod ke aaya hai kya...inshallah, boys played well karte karte dimaag bhi sooj gaya hoga...lol
This is not cool. C — 1500 and D — 1750. And D is way more difficult than C.
For me C was harder than D. I do agree that the problems were harder than on an average div2 round though.
mango_lassi I just checked out your submissions. How are you able to get wrong pretests at a moment and submit the correct code in just 1-2 seconds after that?
What do you mean? I resubmitted B 3 minutes after failing pretests, and C a minute after.
In C I outputted the numbers for the operations in wrong order, so it was very fast to fix
Oh my bad!!! Actually since you out of competition contestant, your submissions were shown in hh:mm format, while others(in-competition contestants' submissions) were in mm:ss format. NVM, I misunderstood minutes as seconds and out of curiosity asked immediately. So sorry.
Same. I feel so stupid. How do you solve C? Edit: Never mind. I got it. So fucking stupid.
In first step make all elements equal to 0 by "2 n 1".
Make all elements equal to a large number say 1000000 by "1 n 1000000".
Now, run a loop from 1 to n-1 (not n) with iterator i and take modulus by 1000000 — i by "1 i 1000000-i".
Total n+1 steps and your task is done.
Note that all indexes less than 'i' will not be affected by taking mod at any step, as they will become smaller in the previous steps itself.
Thus, your final series will look like 1,2,3....,n-2,n-1,1000000 (independent of the array, just depending on the array size).
Why system testing is late today? Any specific reason?
Thanks for an interesting content! And, I have a question on prob. D, which I've been getting on it for an hour. It annoys me.... My question is why I always get a WA on case 1. I don't think I have printed anything larger than 2^30.. Could anyone help me? Thanks a lot! here is my solution.46617886
I don't really understand why people don't test their solutions for interactive problems.
Just set the number of bits to 2 instead of 30 (so that you have less questions) and interact with your program. Just don't forget (like me) to set the number of bits back to 30 when submitting.
Had you checked, you would've seen that your program outputs some weird numbers. The problem seems to be you used uninitialized variables, i.e. you wrote
int a, b;
instead ofint a = 0, b = 0;
.Yeah, you are right! It works. Thanks. I'm so frustrated that I should have made such a mistake. Actually, I tested my solution. That'y why I posted this. Maybe my complier optimized such a mistake so that I couldn't notice. Thank you for your help. It's a stupid mistake.
Cheaters: 46603335 / 46603474 and 46602505 / 46603800 and 46606199 / 46606182
Each pair of submissions seems identical. They will be caught by cheating detector for sure.
How to solve E?
Umm was this round not rated?
It usually takes a while after the contest ends for ratings to change
Why is he doing it? 46594591, 46591499
Happened to be my last Div2 contest, and it was a good one. Thank you!
Why do the top 2 rated coders from your country have 420 in their nicks? Do you guys smoke a lot of pot?
high there, what
Just wondering how to score like you
yh last contest it was too much
paula ANIMALLLLLLL
Got stuck on D for 1.5h during contest without reading E. After contest I read E and solve it in 25 mins :D.
ok. guys. i am new in competetive programming. please help me.
i have a source code on mergesort whenever i need to use that on problem, i just reform that.
include<stdio.h>
int temp[100000];
void mergesort(int low, int high, int num[]){
} int main(){
} i used the code with just a little change of a book here
at B, i just got my solution coincides. why.
how to upload photo here please
I want to upload a photo
my submission is here.46600999
It is better (faster most of the times) and easier to use std::sort instead: http://www.cplusplus.com/reference/algorithm/sort/ . I recommend you study the STL of C++.
How would one approach problem C if we were to determine the minimum number of steps to make the array strictly increasing??
problem D was a really nice up and down dp tnx codeforces and authors for these problems ;)